/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_ubyte_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern23 (); /* [-1, 2] */
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern6 (x1))
    {
    case 0:
      if (const_zerobytes_operand (operands[2], E_HImode))
        return 40; /* pru_and_zerobyteshi */
      if (single_zero_operand (operands[2], E_HImode))
        return 214; /* clearbit_hihi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 364; /* and_implhihihi__noz_z0_z1_z2 */

    case 1:
      if (const_zerobytes_operand (operands[2], E_SImode))
        return 41; /* pru_and_zerobytessi */
      if (single_zero_operand (operands[2], E_SImode))
        return 219; /* clearbit_sisi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 494; /* and_implsisisi__noz_z0_z1_z2 */

    case 2:
      if (const_zerobytes_operand (operands[2], E_DImode))
        return 42; /* pru_and_zerobytesdi */
      if (!reg_or_ubyte_operand (operands[2], E_DImode))
        return -1;
      return 627; /* pru_anddi3 */

    case 3:
      if (single_zero_operand (operands[2], E_QImode))
        return 209; /* clearbit_qiqi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 234; /* and_implqiqiqi__noz_z0_z1_z2 */

    case 4:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 236; /* and_implqiqiqi__z_z0_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 258; /* and_implqiqihi__z_z0_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 268; /* and_implqiqisi__z_z0_noz1_z2 */

    case 5:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 353; /* and_implhihiqi__z_z0_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 366; /* and_implhihihi__z_z0_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 388; /* and_implhihisi__z_z0_noz1_z2 */

    case 6:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 473; /* and_implsisiqi__z_z0_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 483; /* and_implsisihi__z_z0_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 496; /* and_implsisisi__z_z0_noz1_z2 */

    case 7:
      if (single_zero_operand (operands[2], E_QImode))
        return 208; /* clearbit_qiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 233; /* and_implqiqiqi__z_z0_z1_noz2 */

    case 8:
      if (single_zero_operand (operands[2], E_QImode))
        return 210; /* clearbit_qihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 278; /* and_implqihiqi__z_z0_z1_noz2 */

    case 9:
      if (single_zero_operand (operands[2], E_QImode))
        return 211; /* clearbit_qisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 303; /* and_implqisiqi__z_z0_z1_noz2 */

    case 10:
      if (single_zero_operand (operands[2], E_HImode))
        return 212; /* clearbit_hiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 338; /* and_implhiqihi__z_z0_z1_noz2 */

    case 11:
      if (single_zero_operand (operands[2], E_HImode))
        return 213; /* clearbit_hihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 363; /* and_implhihihi__z_z0_z1_noz2 */

    case 12:
      if (single_zero_operand (operands[2], E_HImode))
        return 215; /* clearbit_hisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 403; /* and_implhisihi__z_z0_z1_noz2 */

    case 13:
      if (single_zero_operand (operands[2], E_SImode))
        return 216; /* clearbit_siqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 438; /* and_implsiqisi__z_z0_z1_noz2 */

    case 14:
      if (single_zero_operand (operands[2], E_SImode))
        return 217; /* clearbit_sihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 463; /* and_implsihisi__z_z0_z1_noz2 */

    case 15:
      if (single_zero_operand (operands[2], E_SImode))
        return 218; /* clearbit_sisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 493; /* and_implsisisi__z_z0_z1_noz2 */

    case 16:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 232; /* and_implqiqiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 257; /* and_implqiqihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 267; /* and_implqiqisi__z_z0_z1_z2 */

    case 17:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 277; /* and_implqihiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 287; /* and_implqihihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 297; /* and_implqihisi__z_z0_z1_z2 */

    case 18:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 302; /* and_implqisiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 312; /* and_implqisihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 317; /* and_implqisisi__z_z0_z1_z2 */

    case 19:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 327; /* and_implhiqiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 337; /* and_implhiqihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 347; /* and_implhiqisi__z_z0_z1_z2 */

    case 20:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 352; /* and_implhihiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 362; /* and_implhihihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 387; /* and_implhihisi__z_z0_z1_z2 */

    case 21:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 397; /* and_implhisiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 402; /* and_implhisihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 412; /* and_implhisisi__z_z0_z1_z2 */

    case 22:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 422; /* and_implsiqiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 432; /* and_implsiqihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 437; /* and_implsiqisi__z_z0_z1_z2 */

    case 23:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 447; /* and_implsihiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 452; /* and_implsihihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 462; /* and_implsihisi__z_z0_z1_z2 */

    case 24:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 472; /* and_implsisiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 482; /* and_implsisihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 492; /* and_implsisisi__z_z0_z1_z2 */

    default:
      return -1;
    }
}
