/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern2 (); /* [-1, 2] */
}

int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !shift_operand (operands[2], i1))
    return -1;
  return pattern2 (); /* [-1, 2] */
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !shift_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !shift_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !shift_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern8 (x3))
        {
        case 0:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 242; /* xor_implqiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 261; /* xor_implqiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 271; /* xor_implqiqisi__z_z0_z1_z2 */

        case 1:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 281; /* xor_implqihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 291; /* xor_implqihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 299; /* xor_implqihisi__z_z0_z1_z2 */

        case 2:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 306; /* xor_implqisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 314; /* xor_implqisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 321; /* xor_implqisisi__z_z0_z1_z2 */

        case 3:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 331; /* xor_implhiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 341; /* xor_implhiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 349; /* xor_implhiqisi__z_z0_z1_z2 */

        case 4:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 356; /* xor_implhihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 372; /* xor_implhihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 391; /* xor_implhihisi__z_z0_z1_z2 */

        case 5:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 399; /* xor_implhisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 406; /* xor_implhisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 416; /* xor_implhisisi__z_z0_z1_z2 */

        case 6:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 426; /* xor_implsiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 434; /* xor_implsiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 441; /* xor_implsiqisi__z_z0_z1_z2 */

        case 7:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 449; /* xor_implsihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 456; /* xor_implsihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 466; /* xor_implsihisi__z_z0_z1_z2 */

        case 8:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 476; /* xor_implsisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 486; /* xor_implsisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 502; /* xor_implsisisi__z_z0_z1_z2 */

        case 9:
          return 243; /* xor_implqiqiqi__z_z0_z1_noz2 */

        case 10:
          return 282; /* xor_implqihiqi__z_z0_z1_noz2 */

        case 11:
          return 307; /* xor_implqisiqi__z_z0_z1_noz2 */

        case 12:
          return 342; /* xor_implhiqihi__z_z0_z1_noz2 */

        case 13:
          return 373; /* xor_implhihihi__z_z0_z1_noz2 */

        case 14:
          return 407; /* xor_implhisihi__z_z0_z1_noz2 */

        case 15:
          return 442; /* xor_implsiqisi__z_z0_z1_noz2 */

        case 16:
          return 467; /* xor_implsihisi__z_z0_z1_noz2 */

        case 17:
          return 503; /* xor_implsisisi__z_z0_z1_noz2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern9 (x3, 
E_QImode) != 0)
                return -1;
              return 244; /* xor_implqiqiqi__noz_z0_z1_z2 */

            case E_HImode:
              if (pattern9 (x3, 
E_HImode) != 0)
                return -1;
              return 374; /* xor_implhihihi__noz_z0_z1_z2 */

            case E_SImode:
              if (pattern9 (x3, 
E_SImode) != 0)
                return -1;
              return 504; /* xor_implsisisi__noz_z0_z1_z2 */

            case E_DImode:
              if (pattern9 (x3, 
E_DImode) != 0)
                return -1;
              return 629; /* pru_xordi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1 (x3))
            {
            case 0:
              if (reg_or_ubyte_operand (operands[2], E_QImode))
                return 246; /* xor_implqiqiqi__z_z0_noz1_z2 */
              if (reg_or_ubyte_operand (operands[2], E_HImode))
                return 262; /* xor_implqiqihi__z_z0_noz1_z2 */
              if (!reg_or_ubyte_operand (operands[2], E_SImode))
                return -1;
              return 272; /* xor_implqiqisi__z_z0_noz1_z2 */

            case 1:
              if (reg_or_ubyte_operand (operands[2], E_QImode))
                return 357; /* xor_implhihiqi__z_z0_noz1_z2 */
              if (reg_or_ubyte_operand (operands[2], E_HImode))
                return 376; /* xor_implhihihi__z_z0_noz1_z2 */
              if (!reg_or_ubyte_operand (operands[2], E_SImode))
                return -1;
              return 392; /* xor_implhihisi__z_z0_noz1_z2 */

            case 2:
              if (reg_or_ubyte_operand (operands[2], E_QImode))
                return 477; /* xor_implsisiqi__z_z0_noz1_z2 */
              if (reg_or_ubyte_operand (operands[2], E_HImode))
                return 487; /* xor_implsisihi__z_z0_noz1_z2 */
              if (!reg_or_ubyte_operand (operands[2], E_SImode))
                return -1;
              return 506; /* xor_implsisisi__z_z0_noz1_z2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
