/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern4 (x1, 
E_QImode); /* [-1, 2] */

    case E_HImode:
      res = pattern4 (x1, 
E_HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_SImode:
      res = pattern4 (x1, 
E_SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern6 (x1))
    {
    case 0:
      if (const_fillbytes_operand (operands[2], E_HImode))
        return 37; /* pru_ior_fillbyteshi */
      if (single_one_operand (operands[2], E_HImode))
        return 226; /* setbit_hihi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 369; /* ior_implhihihi__noz_z0_z1_z2 */

    case 1:
      if (const_fillbytes_operand (operands[2], E_SImode))
        return 38; /* pru_ior_fillbytessi */
      if (single_one_operand (operands[2], E_SImode))
        return 231; /* setbit_sisi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 499; /* ior_implsisisi__noz_z0_z1_z2 */

    case 2:
      if (const_fillbytes_operand (operands[2], E_DImode))
        return 39; /* pru_ior_fillbytesdi */
      if (!reg_or_ubyte_operand (operands[2], E_DImode))
        return -1;
      return 628; /* pru_iordi3 */

    case 3:
      if (single_one_operand (operands[2], E_QImode))
        return 221; /* setbit_qiqi__noz */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 239; /* ior_implqiqiqi__noz_z0_z1_z2 */

    case 4:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 241; /* ior_implqiqiqi__z_z0_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 260; /* ior_implqiqihi__z_z0_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 270; /* ior_implqiqisi__z_z0_noz1_z2 */

    case 5:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 355; /* ior_implhihiqi__z_z0_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 371; /* ior_implhihihi__z_z0_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 390; /* ior_implhihisi__z_z0_noz1_z2 */

    case 6:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 475; /* ior_implsisiqi__z_z0_noz1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 485; /* ior_implsisihi__z_z0_noz1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 501; /* ior_implsisisi__z_z0_noz1_z2 */

    case 7:
      if (single_one_operand (operands[2], E_QImode))
        return 220; /* setbit_qiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 238; /* ior_implqiqiqi__z_z0_z1_noz2 */

    case 8:
      if (single_one_operand (operands[2], E_QImode))
        return 222; /* setbit_qihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 280; /* ior_implqihiqi__z_z0_z1_noz2 */

    case 9:
      if (single_one_operand (operands[2], E_QImode))
        return 223; /* setbit_qisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_QImode))
        return -1;
      return 305; /* ior_implqisiqi__z_z0_z1_noz2 */

    case 10:
      if (single_one_operand (operands[2], E_HImode))
        return 224; /* setbit_hiqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 340; /* ior_implhiqihi__z_z0_z1_noz2 */

    case 11:
      if (single_one_operand (operands[2], E_HImode))
        return 225; /* setbit_hihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 368; /* ior_implhihihi__z_z0_z1_noz2 */

    case 12:
      if (single_one_operand (operands[2], E_HImode))
        return 227; /* setbit_hisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_HImode))
        return -1;
      return 405; /* ior_implhisihi__z_z0_z1_noz2 */

    case 13:
      if (single_one_operand (operands[2], E_SImode))
        return 228; /* setbit_siqi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 440; /* ior_implsiqisi__z_z0_z1_noz2 */

    case 14:
      if (single_one_operand (operands[2], E_SImode))
        return 229; /* setbit_sihi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 465; /* ior_implsihisi__z_z0_z1_noz2 */

    case 15:
      if (single_one_operand (operands[2], E_SImode))
        return 230; /* setbit_sisi__z */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 498; /* ior_implsisisi__z_z0_z1_noz2 */

    case 16:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 237; /* ior_implqiqiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 259; /* ior_implqiqihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 269; /* ior_implqiqisi__z_z0_z1_z2 */

    case 17:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 279; /* ior_implqihiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 289; /* ior_implqihihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 298; /* ior_implqihisi__z_z0_z1_z2 */

    case 18:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 304; /* ior_implqisiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 313; /* ior_implqisihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 319; /* ior_implqisisi__z_z0_z1_z2 */

    case 19:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 329; /* ior_implhiqiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 339; /* ior_implhiqihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 348; /* ior_implhiqisi__z_z0_z1_z2 */

    case 20:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 354; /* ior_implhihiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 367; /* ior_implhihihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 389; /* ior_implhihisi__z_z0_z1_z2 */

    case 21:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 398; /* ior_implhisiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 404; /* ior_implhisihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 414; /* ior_implhisisi__z_z0_z1_z2 */

    case 22:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 424; /* ior_implsiqiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 433; /* ior_implsiqihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 439; /* ior_implsiqisi__z_z0_z1_z2 */

    case 23:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 448; /* ior_implsihiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 454; /* ior_implsihihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 464; /* ior_implsihisi__z_z0_z1_z2 */

    case 24:
      if (reg_or_ubyte_operand (operands[2], E_QImode))
        return 474; /* ior_implsisiqi__z_z0_z1_z2 */
      if (reg_or_ubyte_operand (operands[2], E_HImode))
        return 484; /* ior_implsisihi__z_z0_z1_z2 */
      if (!reg_or_ubyte_operand (operands[2], E_SImode))
        return -1;
      return 497; /* ior_implsisisi__z_z0_z1_z2 */

    default:
      return -1;
    }
}
