/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      return pattern5 (x1); /* [-1, 8] */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          res = pattern7 (x1, 
E_QImode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        case E_HImode:
          res = pattern7 (x1, 
E_HImode);
          if (res >= 0)
            return res + 12; /* [12, 14] */
          return -1;

        case E_SImode:
          res = pattern7 (x1, 
E_SImode);
          if (res >= 0)
            return res + 15; /* [15, 17] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern23 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern34 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern22 (x3, 
E_DImode) != 0)
                return -1;
              return 36; /* subdi3 */

            case E_QImode:
              if (pattern22 (x3, 
E_QImode) != 0)
                return -1;
              return 96; /* sub_implqiqiqi__noz_z1_z2 */

            case E_HImode:
              if (pattern22 (x3, 
E_HImode) != 0)
                return -1;
              return 118; /* sub_implhihihi__noz_z1_z2 */

            case E_SImode:
              if (pattern22 (x3, 
E_SImode) != 0)
                return -1;
              return 140; /* sub_implsisisi__noz_z1_z2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern24 (x3, 
E_QImode))
                {
                case 0:
                  return 97; /* sub_implqiqiqi__z_noz1_z2 */

                case 1:
                  return 99; /* sub_implqiqihi__z_noz1_z2 */

                case 2:
                  return 101; /* sub_implqiqisi__z_noz1_z2 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern24 (x3, 
E_HImode))
                {
                case 0:
                  return 115; /* sub_implhihiqi__z_noz1_z2 */

                case 1:
                  return 119; /* sub_implhihihi__z_noz1_z2 */

                case 2:
                  return 121; /* sub_implhihisi__z_noz1_z2 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern24 (x3, 
E_SImode))
                {
                case 0:
                  return 135; /* sub_implsisiqi__z_noz1_z2 */

                case 1:
                  return 137; /* sub_implsisihi__z_noz1_z2 */

                case 2:
                  return 141; /* sub_implsisisi__z_noz1_z2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern25 (x3, 
E_QImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                {
                  switch (pattern23 ())
                    {
                    case 0:
                      return 94; /* sub_implqiqiqi__z_z1_z2 */

                    case 1:
                      return 98; /* sub_implqiqihi__z_z1_z2 */

                    case 2:
                      return 100; /* sub_implqiqisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                {
                  switch (pattern23 ())
                    {
                    case 0:
                      return 102; /* sub_implqihiqi__z_z1_z2 */

                    case 1:
                      return 104; /* sub_implqihihi__z_z1_z2 */

                    case 2:
                      return 105; /* sub_implqihisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              switch (pattern23 ())
                {
                case 0:
                  return 106; /* sub_implqisiqi__z_z1_z2 */

                case 1:
                  return 108; /* sub_implqisihi__z_z1_z2 */

                case 2:
                  return 109; /* sub_implqisisi__z_z1_z2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (pattern25 (x3, 
E_HImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                {
                  switch (pattern23 ())
                    {
                    case 0:
                      return 110; /* sub_implhiqiqi__z_z1_z2 */

                    case 1:
                      return 111; /* sub_implhiqihi__z_z1_z2 */

                    case 2:
                      return 113; /* sub_implhiqisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                {
                  switch (pattern23 ())
                    {
                    case 0:
                      return 114; /* sub_implhihiqi__z_z1_z2 */

                    case 1:
                      return 116; /* sub_implhihihi__z_z1_z2 */

                    case 2:
                      return 120; /* sub_implhihisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              switch (pattern23 ())
                {
                case 0:
                  return 122; /* sub_implhisiqi__z_z1_z2 */

                case 1:
                  return 123; /* sub_implhisihi__z_z1_z2 */

                case 2:
                  return 125; /* sub_implhisisi__z_z1_z2 */

                default:
                  return -1;
                }

            case E_SImode:
              if (pattern25 (x3, 
E_SImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                {
                  switch (pattern23 ())
                    {
                    case 0:
                      return 126; /* sub_implsiqiqi__z_z1_z2 */

                    case 1:
                      return 127; /* sub_implsiqihi__z_z1_z2 */

                    case 2:
                      return 128; /* sub_implsiqisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                {
                  switch (pattern23 ())
                    {
                    case 0:
                      return 130; /* sub_implsihiqi__z_z1_z2 */

                    case 1:
                      return 131; /* sub_implsihihi__z_z1_z2 */

                    case 2:
                      return 132; /* sub_implsihisi__z_z1_z2 */

                    default:
                      break;
                    }
                }
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              switch (pattern23 ())
                {
                case 0:
                  return 134; /* sub_implsisiqi__z_z1_z2 */

                case 1:
                  return 136; /* sub_implsisihi__z_z1_z2 */

                case 2:
                  return 138; /* sub_implsisisi__z_z1_z2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern26 (x3, 
E_QImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                return 95; /* sub_implqiqiqi__z_z1_noz2 */
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                return 103; /* sub_implqihiqi__z_z1_noz2 */
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 107; /* sub_implqisiqi__z_z1_noz2 */

            case E_HImode:
              if (pattern26 (x3, 
E_HImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                return 112; /* sub_implhiqihi__z_z1_noz2 */
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                return 117; /* sub_implhihihi__z_z1_noz2 */
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 124; /* sub_implhisihi__z_z1_noz2 */

            case E_SImode:
              if (pattern26 (x3, 
E_SImode) != 0)
                return -1;
              if (reg_or_ubyte_operand (operands[1], E_QImode))
                return 129; /* sub_implsiqisi__z_z1_noz2 */
              if (reg_or_ubyte_operand (operands[1], E_HImode))
                return 133; /* sub_implsihisi__z_z1_noz2 */
              if (!reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 139; /* sub_implsisisi__z_z1_noz2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
